discussion/urls.py
from django.contrib import admin
from django.urls import include, path # import include and path

urlpatterns = [
    path("todolist/", include("todolist.urls")),
    path('admin/', admin.site.urls),
]

todolist/urls.py
from django.urls import path
from . import views # import views.py. dot is because it's in the same folder

app_name= 'todolist'

urlpatterns = [
    path("index", views.index, name="index"),

#   TASKS
    path("task/<int:todoitem_id>", views.todoitem, name="viewtodoitem"),
    path("add_task", views.add_task, name="add_task"),
    path("task/<int:todoitem_id>/update_task", views.update_task, name="update_task"),
    path('task/<int:todoitem_id>/delete_task', views.delete_task, name="delete_task"),

#   EVENTS
    path("event/<int:event_id>", views.event, name="viewevent"),
    path('add_event', views.add_event, name="add_event"),
    path("event/<int:event_id>/update_event", views.update_event, name="update_event"),
    path('event/<int:event_id>/delete_event', views.delete_event, name="delete_event"),

#   USERS
    path("register", views.register, name="register"),
    path("update_user", views.update_user, name="update_user"),
    path("login", views.login_user, name="login"),
    path("logout", views.logout_user, name="logout")
]

todolist/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.

class ToDoItem(models.Model):
    task_name = models.CharField(max_length=50)
    description = models.CharField(max_length=500)
    status = models.CharField(max_length=50, default = "pending")
    date_created = models.DateTimeField("date created", auto_now=False, auto_now_add=False)
    user = models.ForeignKey(User, on_delete=models.RESTRICT, default = "")

class EventItem(models.Model):
    event_name = models.CharField(max_length=50)
    description = models.CharField(max_length=500)
    status = models.CharField(max_length=50, default = "pending")
    date_created = models.DateTimeField("date created", auto_now=False, auto_now_add=False)
    user = models.ForeignKey(User, on_delete=models.RESTRICT, default = "")

todolist/forms.py
from django import forms

class LoginForm(forms.Form):
    username = forms.CharField(label="username", max_length=20, required=True)
    password = forms.CharField(label="password", max_length=20, required=True)

class RegistrationForm(forms.Form):
    username = forms.CharField(label="username", max_length=20, required=True)
    password = forms.CharField(label="password", max_length=20, required=True)
    confirm_password = forms.CharField(label="confirm_password", max_length=20, required=True)
    first_name = forms.CharField(label="first_name", max_length=20, required=True)
    last_name = forms.CharField(label="last_name", max_length=20, required=True)
    email = forms.CharField(label="email", max_length=20, required=True)
    
class AddTaskForm(forms.Form):
    task_name = forms.CharField(label="task_name", max_length=50, required=True)
    description = forms.CharField(label="description", max_length=500, required=True)

class AddEventForm(forms.Form):
    event_name = forms.CharField(label="event_name", max_length=50, required=True)
    description = forms.CharField(label="description", max_length=500, required=True)

class UpdateTaskForm(forms.Form):
    task_name = forms.CharField(label = "task_name", max_length=50)
    description = forms.CharField(label = "description", max_length=500)
    status = forms.CharField(label = "status", max_length=50)

class UpdateEventForm(forms.Form):
    event_name = forms.CharField(label = "event_name", max_length=50)
    description = forms.CharField(label = "description", max_length=500)
    status = forms.CharField(label = "status", max_length=50)

class UpdateUserForm(forms.Form):
    first_name = forms.CharField(label = "first_name", max_length=50, required=True)
    last_name = forms.CharField(label = "last_name", max_length=50, required=True)
    password = forms.CharField(label = "password", max_length=50, required=True)
    confirm_password = forms.CharField(label="confirm_password", max_length=20, required=True)

todolist/views.py
from .forms import LoginForm, AddTaskForm, UpdateTaskForm, RegistrationForm, AddEventForm, UpdateEventForm, UpdateUserForm
from django.forms.models import model_to_dict
from django.shortcuts import render, redirect, get_object_or_404

# Create your views here.

from django.http import HttpResponse  # Like res.send() or res.json()

# local import
from .models import ToDoItem, EventItem

# import template
# from django.template import loader

# import built in user model
from django.contrib.auth.models import User

# import
from django.contrib.auth import authenticate, login, logout

from django.utils import timezone


def index(req):
    todoitem_list = ToDoItem.objects.filter(user_id=req.user.id)
    event_list = EventItem.objects.filter(user_id=req.user.id)
    context = {
        "todoitem_list": todoitem_list,
        "event_list": event_list,
        "user": req.user
    }
    return render(req, "index.html", context)


def todoitem(req, todoitem_id):
    # response  = f"You are viewing the details of {todoitem_id}"
    # return HttpResponse(response)

    todoitem = get_object_or_404(ToDoItem, pk=todoitem_id)
    return render(req, "todoitem.html", model_to_dict(todoitem))


def add_task(req):
    context = {}

    if req.method == "POST":
        form = AddTaskForm(req.POST)

        if form.is_valid() == False:
            form = AddTaskForm()
        else:
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']

            duplicates = ToDoItem.objects.filter(
                task_name=task_name, user_id=req.user.id)

        if not duplicates:
            ToDoItem.objects.create(
                task_name=task_name, description=description, date_created=timezone.now(), user_id=req.user.id)
            return redirect("todolist:index")
        else:
            context = {
                "error": True
            }

    return render(req, "add_task.html", context)

def event(req, event_id):
    event = get_object_or_404(EventItem, pk=event_id)
    return render(req, "event.html", model_to_dict(event))

def add_event(req):
    context = {}

    if req.method == "POST":
        form = AddEventForm(req.POST)

        if form.is_valid() == False:
            form = AddEventForm()
        else:
            event_name = form.cleaned_data['event_name']
            description = form.cleaned_data['description']

            duplicates = EventItem.objects.filter(
                event_name = event_name, user_id=req.user.id)

        if not duplicates:
            EventItem.objects.create(
                event_name = event_name, description = description, date_created=timezone.now(), user_id=req.user.id)
            return redirect("todolist:index")
        else:
            context = {
                "error": True
            }

    return render(req, "add_event.html", context)

def update_event(req, event_id):
    event = EventItem.objects.filter(pk = event_id)

    context = {
        'user': req.user,
        'event_id': event_id,
        'event_name': event[0].event_name,
        'description': event[0].description,
        'status': event[0].status
    }

    if req.method == "POST":
        form = UpdateEventForm(req.POST)

        if form.is_valid() == False:
            form = UpdateEventForm()
        else: 
            event_name = form.cleaned_data['event_name']
            description = form.cleaned_data['description']
            status = form.cleaned_data['status']
        
        if event: 
            event[0].event_name = event_name
            event[0].description = description
            event[0].status = status

            event[0].save()

            return redirect("todolist:viewevent", event_id=event[0].id)
        else:
            context = {
                "error": True
            }
            
    return render(req, "update_event.html", context)

def update_task(req, todoitem_id):
    todoitem = ToDoItem.objects.filter(pk = todoitem_id)

    context = {
        'user': req.user,
        'todoitem_id': todoitem_id,
        'task_name': todoitem[0].task_name,
        'description': todoitem[0].description,
        'status': todoitem[0].status
    }

    if req.method == "POST":
        form = UpdateTaskForm(req.POST)

        if form.is_valid() == False:
            form = UpdateTaskForm()
        else: 
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']
            status = form.cleaned_data['status']
        
        if todoitem: 
            todoitem[0].task_name = task_name
            todoitem[0].description = description
            todoitem[0].status = status

            todoitem[0].save()

            return redirect("todolist:viewtodoitem", todoitem_id=todoitem[0].id)
        else:
            context = {
                "error": True
            }
            
    return render(req, "update_task.html", context)

def delete_event(req, event_id):
    EventItem.objects.filter(pk = event_id).delete()
    return redirect('todolist:index')

def delete_task(req, todoitem_id):
    ToDoItem.objects.filter(pk = todoitem_id).delete()
    return redirect('todolist:index')
        
def register(req):
    context = {}
    users = User.objects.all()
    is_user_registered = False

    user = User()

    if req.method == "POST":
        form = RegistrationForm(req.POST)

        if form.is_valid() == False:
            form = RegistrationForm()
        else:
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']
            confirm_password = form.cleaned_data['confirm_password']
            first_name = form.cleaned_data['first_name']
            last_name = form.cleaned_data['last_name']
            email = form.cleaned_data['email']

            if password != confirm_password:
                    context = { 
                        'password_match': False
                    }
                    return render(req, 'register.html', context)
            else:
                for registed_user in users:
                    if registed_user.username == username:
                        is_user_registered = True
                        break

                context = {
                    "is_user_registered": is_user_registered
                }

                if is_user_registered == False:
                    user.username = username
                    user.first_name = first_name
                    user.last_name = last_name
                    user.email = email
                    user.set_password(password)
                    user.is_staff = False
                    user.is_active = True

                    user.save()
                    return redirect("todolist:login")

    return render(req, "register.html", context)



def update_user(req):
    user = User.objects.get(pk = req.user.id)
    context = {
        "first_name": user.first_name,
        "last_name": user.last_name
    }
    
    if req.method == "POST":
        form = UpdateUserForm(req.POST)

        if form.is_valid() == False:
            form = UpdateUserForm()
        else: 
            first_name = form.cleaned_data['first_name']
            last_name = form.cleaned_data['last_name']
            password = form.cleaned_data['password']
            confirm_password = form.cleaned_data['confirm_password']
        
        if user is not None: 
            if password != confirm_password:
                context = {
                    **context,
                    'password_match': False
                }
                return render(req, "update_user.html", context)
            else:
                user.first_name = first_name
                user.last_name = last_name
                user.set_password(password)
                user.save()
                return redirect("todolist:index")
            
    return render(req, "update_user.html", context)    

def login_user(req):
    context = {

    }

    if req.method == "POST":
        form = LoginForm(req.POST)

        if form.is_valid() == False:
            form = LoginForm()
        else:
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']

            user = authenticate(username=username, password=password)

            if user is not None:
                context = {
                    "username": username,
                    "password": password
                }
                login(req, user)
                return redirect("todolist:index")
            else:
                context = {
                    'error': True
                }

    return render(req, 'login.html', context)


def logout_user(req):
    logout(req)
    return redirect("todolist:index")

todolist/templates/add_event.html
{% extends 'base.html' %} {% block title %} Add Event {% endblock title %}
{%block content%}
<div class="container">
    <div class="row">
        <div class="col-6 offset-3">
            {% if error == True %}
            <p class="text-danger">
                Ulit-ulit na event? Tapusin mo muna yung isa.
            </p>
            {% endif %}
            <form action="{% url 'todolist:add_event' %}" method="POST">
                {% csrf_token %}

                <div class="mb-3">
                    <label for="event_name">Event Name: </label>
                    <input
                        class="form-control"
                        id="event_name"
                        type="text"
                        name="event_name"
                        value="{{ event_name }}"
                        maxlength="50"
                        required
                    />
                </div>

                <div class="mb-3">
                    <label for="description">Description: </label>
                    <textarea
                        class="form-control"
                        name="description"
                        value="{{ description }}"
                        required
                    ></textarea>
                </div>

                <div class="text-center">
                    <input
                        class="btn btn-success"
                        type="submit"
                        value="Add Event"
                    />
                </div>
            </form>
        </div>
    </div>
</div>
{% endblock content%}

todolist/templates/add_task.html
{% extends 'base.html' %} {% block title %} Add Task {% endblock title %}
{%block content%}
<div class="container">
    <div class="row">
        <div class="col-6 offset-3">
            {% if error == True %}
            <p class="text-danger">
                Meron na nya. Gawin mo na kaya?
            </p>
            {% endif %}
            <form action="{% url 'todolist:add_task' %}" method="POST">
                {% csrf_token %}

                <div class="mb-3">
                    <label for="task_name">Task Name: </label>
                    <input
                        class="form-control"
                        id="task_name"
                        type="text"
                        name="task_name"
                        value="{{ task_name }}"
                        maxlength="50"
                        required
                    />
                </div>

                <div class="mb-3">
                    <label for="description">Description: </label>
                    <textarea
                        class="form-control"
                        name="description"
                        value="{{ description }}"
                        required
                    ></textarea>
                </div>

                <div class="text-center">
                    <input
                        class="btn btn-success"
                        type="submit"
                        value="Add Task"
                    />
                </div>
            </form>
        </div>
    </div>
</div>
{% endblock content%}

todolist/templates/event.html
{% extends 'base.html' %}

{% block title %} Events {% endblock title %}

{% block content %} 
    <div class="text-center mt-3">
        <h1>Event</h1>
        <h1>{{event_name}}</h1>
        <h3>Desc:</h3>
        <p>{{description}}</p>
        <h3>Status:</h3>
        <p>{{status}}</p>

        <button class="btn btn-success mx-1 ">
            <a href="{% url 'todolist:update_event' id %}" class="text-decoration-none">Update Event</a>
        </button>

        <button class="btn btn-success mx-1 ">
            <a href="{% url 'todolist:delete_event' id %}" class="text-decoration-none">Delete Event</a>
        </button>

        <button class="btn btn-warning mx-1 ">
            <a href="{% url 'todolist:index' %}" class="text-decoration-none"> Back To Index Page.</a>
        </button>
    </div>
{% endblock content %}

todolist/templates/login.html
{% extends 'base.html' %} 

{% block title %} Login {% endblock %} 

{% block content %}
<h1 class="text-center my-3">Login Form</h1>
<div class="container shadow rounded py-3 w-50">
    <div class="row">
        <div class="col-6 offset-3">
            {% if error == True %}
                <p class="text-danger">Registered ka ba? Sure ka? Double check mo nga ang username o password mo.</p>
            {% endif %}
            <form action="{% url 'todolist:login' %}" method="POST">


                {% comment %} IMPORT SI csrf_token {% endcomment %}
                {% csrf_token %}


                <div class="mb-3">
                    <label for="exampleInputEmail1" class="form-label"
                        >Username</label
                    >
                    <input
                        type="text"
                        class="form-control"
                        id="username"
                        value="{{ username }}"
                        name="username"
                        maxlength="20"
                        required
                    />
                </div>
                <div class="mb-3">
                    <label for="password" class="form-label"
                        >Password</label
                    >
                    <input
                        type="password"
                        class="form-control"
                        id="password"
                        value="{{ password }}"
                        name="password"
                        maxlength="20"
                        required
                    />
                </div>
                <button type="submit" class="btn btn-primary">Login</button>
            </form>
        </div>
    </div>
</div>

{% endblock %}

todolist/templates/register.html
{% extends 'base.html' %} 

{% block title %} Register {% endblock %} 

{% block content %}
<h1 class="text-center my-3">Register</h1>
<div class="container shadow rounded py-3 w-50">
    <div class="row">
        <div class="col-6 offset-3">

            {% if password_match == False%}
            <p class="text-danger">Passwords must match.</p>
            {% endif%}
            
            {% if is_user_registered == True %}
                <p class="text-danger">Username already taken.</p>
            {% endif %}
            <form action="{% url 'todolist:register' %}" method="POST">

                {% csrf_token %}

                <div class="mb-3">
                    <label for="username" class="form-label"
                        >Username</label
                    >
                    <input
                        type="text"
                        class="form-control"
                        id="username"
                        value="{{ username }}"
                        name="username"
                        maxlength="20"
                        required
                    />
                </div>
                <div class="mb-3">
                    <label for="first_name" class="form-label"
                        >First Name</label
                    >
                    <input
                        type="text"
                        class="form-control"
                        id="first_name"
                        value="{{ first_name }}"
                        name="first_name"
                        maxlength="20"
                        required
                    />
                </div>
                <div class="mb-3">
                    <label for="last_name" class="form-label"
                        >Last Name</label
                    >
                    <input
                        type="text"
                        class="form-control"
                        id="last_name"
                        value="{{ last_name }}"
                        name="last_name"
                        maxlength="20"
                        required
                    />
                </div>
                <div class="mb-3">
                    <label for="email" class="form-label"
                        >Email</label
                    >
                    <input
                        type="email"
                        class="form-control"
                        id="email"
                        value="{{ email }}"
                        name="email"
                        maxlength="20"
                        required
                    />
                </div>
                <div class="mb-3">
                    <label for="password" class="form-label"
                        >Password</label
                    >
                    <input
                        type="password"
                        class="form-control"
                        id="password"
                        value="{{ password }}"
                        name="password"
                        maxlength="20"
                        required
                    />
                </div>
                <div class="mb-3">
                    <label for="confirm_password" class="form-label"
                        >Confirm Password</label
                    >
                    <input
                        type="password"
                        class="form-control"
                        id="confirm_password"
                        value="{{ confirm_password }}"
                        name="confirm_password"
                        maxlength="20"
                        required
                    />
                </div>
                <button type="submit" class="btn btn-primary">Register</button>
            </form>
        </div>
    </div>
</div>

{% endblock %}



<!-- {% if is_user_registered == False %}

    <h1>User Successfully Creates!</h1>
    <p>The Account for {{first_name}} {{last_name}} has been created!</p>

{% else %}
    <h1>Duplicate User Found!</h1>
    <p>A duplicate user has been found, user creation unsuccessful</p>


{% endif%} -->

todolist/templates/todoitem.html
{% extends 'base.html' %}

{% block title %} Tasks {% endblock title %}

{% block content %} 
    <div class="text-center mt-3">
        <h1>Task</h1>
        <h1>{{task_name}}</h1>
        <h3>Desc:</h3>
        <p>{{description}}</p>
        <h3>Status:</h3>
        <p>{{status}}</p>

        <button class="btn btn-success mx-1 ">
            <a href="{% url 'todolist:update_task' id %}" class="text-decoration-none">Update Task</a>
        </button>

        <button class="btn btn-success mx-1 ">
            <a href="{% url 'todolist:delete_task' id %}" class="text-decoration-none">Delete Task</a>
        </button>

        <button class="btn btn-warning mx-1 ">
            <a href="{% url 'todolist:index' %}" class="text-decoration-none"> Back To Index Page.</a>
        </button>
    </div>
{% endblock content %}

todolist/templates/update_event.html
{% extends 'base.html' %}

{% block title %} Update Event {% endblock title %}

{% block content %}
    {% if user.is_anonymous == False %}
    <div class="container">
        <div class="row">
            <div class="col-6 offset-3">
                <h1 class="text-center mt-3">Update event</h1>

                {% if error == True %}
                    <p class="text-center text-danger">event not Found</p>
                {% endif %}
                <form action="{% url 'todolist:update_event' event_id %}" method="POST">
                    {% csrf_token %}

                    <div class="mb-3">
                        <label for="event_name">Event Name: </label>
                        <input class="form-control" id="event_name" type="text" name="event_name" value="{{ event_name }}" maxlength="50" required>
                    </div>

                    <div class="mb-3">
                        <label for="description">Description: </label>
                        <textarea class="form-control" name="description" required>{{ description }}</textarea>
                    </div>

                    <div class="mb-3">
                        <label for="status">Status: </label>
                        <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
                    </div>

                    <div class="text-center">
                        <input class="btn btn-success" type="submit" value="Update Event">
                    </div>
                </form>
            </div>
        </div>
    </div>
    {% endif %}


{% endblock content %}

todolist/templates/update_task.html
{% extends 'base.html' %}

{% block title %} Update Task {% endblock title %}

{% block content %}
    {% if user.is_anonymous == False %}
    <div class="container">
        <div class="row">
            <div class="col-6 offset-3">
                <h1 class="text-center mt-3">Update Task</h1>

                {% if error == True %}
                    <p class="text-center text-danger">Task not Found</p>
                {% endif %}
                <form action="{% url 'todolist:update_task' todoitem_id %}" method="POST">
                    {% csrf_token %}

                    <div class="mb-3">
                        <label for="task_name">Task Name: </label>
                        <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
                    </div>

                    <div class="mb-3">
                        <label for="description">Description: </label>
                        <textarea class="form-control" name="description" required>{{ description }}</textarea>
                    </div>

                    <div class="mb-3">
                        <label for="status">Status: </label>
                        <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
                    </div>

                    <div class="text-center">
                        <input class="btn btn-success" type="submit" value="Update Task">
                    </div>
                </form>
            </div>
        </div>
    </div>
    {% endif %}


{% endblock content %}

todolist/templates/update_user.html
{% extends 'base.html' %} 

{% block title %} Update User {% endblock %} 

{% block content %}
<h1 class="text-center my-3">Update User</h1>
<div class="container shadow rounded py-3 w-50">
    <div class="row">
        <div class="col-6 offset-3">
            {% if password_match == False%}
            <p class="text-danger">Passwords must match.</p>
            {% endif%}
            
            {% if is_user_registered == True %}
                <p class="text-danger">Username already taken.</p>
            {% endif %}
            <form action="{% url 'todolist:update_user' %}" method="POST">

                {% csrf_token %}

                <div class="mb-3">
                    <label for="first_name" class="form-label"
                        >First Name</label
                    >
                    <input
                        type="text"
                        class="form-control"
                        id="first_name"
                        value="{{ first_name }}"
                        name="first_name"
                        maxlength="20"
                        required
                    />
                </div>
                <div class="mb-3">
                    <label for="last_name" class="form-label"
                        >Last Name</label
                    >
                    <input
                        type="text"
                        class="form-control"
                        id="last_name"
                        value="{{ last_name }}"
                        name="last_name"
                        maxlength="20"
                        required
                    />
                </div>

                <div class="mb-3">
                    <label for="password" class="form-label"
                        >New Password</label
                    >
                    <input
                        type="password"
                        class="form-control"
                        id="password"
                        value="{{ password }}"
                        name="password"
                        maxlength="20"
                        required
                    />
                </div>
                <div class="mb-3">
                    <label for="confirm_password" class="form-label"
                        >Confirm New Password</label
                    >
                    <input
                        type="password"
                        class="form-control"
                        id="confirm_password"
                        value="{{ confirm_password }}"
                        name="confirm_password"
                        maxlength="20"
                        required
                    />
                </div>
                <button type="submit" class="btn btn-primary">Update</button>
            </form>
        </div>
    </div>
</div>

{% endblock %}